import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 16.01.2007
  * @author
  */

public class Gui extends JFrame {
  // Anfang Variablen
  private TextDatei textDatei;
  private JMenuBar jMenueBar = new JMenuBar();
  private JMenu jDateiMenu = new JMenu("Datei");
  private JMenuItem jLesenItem = new JMenuItem("Datei lesen");
  private JMenuItem jSchreibenItem = new JMenuItem("Datei schreiben");
  private JMenuItem jNamenItem = new JMenuItem("Dateinamen");
  private JMenuItem jBeendenItem = new JMenuItem("Beenden");
  private JMenu jBearbeitenMenu = new JMenu("Bearbeiten");
  private JMenuItem jAnhaengenItem = new JMenuItem("Wort anhngen");
  private JMenuItem jLoeschenItem = new JMenuItem("aktuellen lschen");
  private JMenuItem jLoescheAlleItem = new JMenuItem("alle lschen");
  private JTextField jTextField1 = new JTextField();
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JFileChooser jfco = new JFileChooser();
  private JFileChooser jfcs = new JFileChooser();
  // Ende Variablen

  public Gui(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { System.exit(0); }
    });
    int frameWidth = 374;
    int frameHeight = 139;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2 ;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    setJMenuBar(jMenueBar);
    jMenueBar.add(jDateiMenu);
    jMenueBar.add(jBearbeitenMenu);
    jDateiMenu.add(jLesenItem);
    jDateiMenu.add(jSchreibenItem);
    jDateiMenu.add(jBeendenItem);
    jBearbeitenMenu.add(jAnhaengenItem);
    jBearbeitenMenu.add(jLoeschenItem);
    jBearbeitenMenu.add(jLoescheAlleItem);
    // Dateimenue
    jBeendenItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) { System.exit(0); }
      });
    jLesenItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) { lesenAktion(); }
      });
    jSchreibenItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) { schreibenAktion(); }
      });
    // Bearbeitenmenue
    jAnhaengenItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) { anhaengenAktion(); }
      });
    jLoeschenItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) { loeschenAktion(); }
      });
    jLoescheAlleItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) { loescheAlleAktion(); }
      });

    jTextField1.setBounds(88, 24, 177, 24);
    jTextField1.setText("");
    cp.add(jTextField1);
    // ENTER - Taste verarbeiten
    jTextField1.addKeyListener(new KeyAdapter() {
      public void keyPressed(KeyEvent evt) {
        int key=evt.getKeyCode();
        if (key==KeyEvent.VK_ENTER)anhaengenAktion();
      }
    });

    jButton1.setBounds(8, 24, 75, 25);
    jButton1.setText("<=");
    cp.add(jButton1);
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });

    jButton2.setBounds(272, 24, 75, 25);
    jButton2.setText("=>");
    cp.add(jButton2);
    jButton2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });

    // Ende Komponenten

    textDatei = new TextDatei();
    setResizable(false);
    setVisible(true);
  }
  
  // Anfang Ereignisprozeduren
  private void lesenAktion() {
    String dateiname=jfcoOpenFilename();
    if (dateiname!=null) {
      textDatei.setzeDateiNamen(dateiname);
      textDatei.dateiLesen();
    }
  }
  private void schreibenAktion() {
    String dateiname=jfcsSaveFilename();
    if (dateiname!=null) {
      textDatei.setzeDateiNamen(dateiname);
      textDatei.dateiSchreiben();
    }
  }

  private void anhaengenAktion() {
    textDatei.anhaengen(jTextField1.getText());
    aktualisiere();
  }
  private void loeschenAktion() {
    textDatei.loesche();
    aktualisiere();
  }
  private void loescheAlleAktion() {
    textDatei.loescheAlle();
    aktualisiere();
  }
  public void jButton1ActionPerformed(ActionEvent evt) {
    textDatei.zurueck();
    aktualisiere();
  }
  public void jButton2ActionPerformed(ActionEvent evt) {
    textDatei.weiter();
    aktualisiere();
  }
  private void aktualisiere() {
    jTextField1.setText(textDatei.aktuellerWert());
  }

  public String jfcsSaveFilename() {
    jfcs.setDialogTitle("Speichere Datei");
    if (jfcs.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
      return jfcs.getSelectedFile().getPath();
    } else {
      return null;
    }
  }

  public String jfcoOpenFilename() {
    jfco.setDialogTitle("ffne Datei");
    if (jfco.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
      return jfco.getSelectedFile().getPath();
    } else {
      return null;
    }
  }

  // Ende Ereignisprozeduren

  public static void main(String[] args) {
    new Gui("Gui");
  }
}

